from datetime import datetime

from .headhunting import Headhunting
from .orundum import Orundum
from .sign_in import SignIn


class SignInManager:
    solver_name = "签到管理器"
    scheduler_stop_time = None

    def run(self) -> bool:
        if datetime.now() < datetime(2024, 11, 15):
            solver_list = [SignIn(), Orundum(), Headhunting()]
            for solver in solver_list:
                solver.scheduler_stop_time = self.scheduler_stop_time
                if not solver.run():
                    return False
        return True
